class Integrator {
  float value;
  float vel;
  float accel;
  float force;
  float mass = 1;
  float damping =  0.5f;
  float attraction = 0.2f;
  boolean targeting;
  float target;

  Integrator(float value) {
    this.value = value;
  }

  Integrator(float value, float damping, float attraction) {
    this.value = value;
    this.damping = damping;
    this.attraction = attraction;
  }

  void set(float v) {
    value = v;
  }
  
  void update() {
    if (targeting) {
      force += attraction * (target - value);      
    }

    accel = force / mass;
    vel = (vel + accel) * damping;
    value += vel;

    force = 0;
  }

  void target(float t) {
    targeting = true;
    target = t;
  }

  void noTarget() {
    targeting = false;
  }
}
